Imports Roslyn.Compilers
Imports Roslyn.Compilers.Common
Imports Roslyn.Compilers.Csharp
Imports Roslyn.Services
Imports System.Text
Imports System.Threading
Imports System.Threading.Tasks

Namespace FindingDateTimeNow
	Public NotInheritable Class ChangeDateTimeKindToUtcCodeAction
		Implements ICodeAction

		Private document As IDocument
		Private argumentNode As ArgumentSyntax

		Public Sub New(ByVal document As IDocument, ByVal argumentNode As ArgumentSyntax)
			Me.document = document
			Me.argumentNode = argumentNode
		End Sub

		Public ReadOnly Property Description As String Implements ICodeAction.Description
			Get
				Return "Change DateTimeKind to Utc"
			End Get
		End Property

        Public Function GetEdit(Optional ByVal cancellationToken As CancellationToken = Nothing) As CodeActionEdit Implements ICodeAction.GetEdit
            Dim currentKindNode = (TryCast(Me.argumentNode.Expression, MemberAccessExpressionSyntax)).Name
            Dim utcNode = Syntax.IdentifierName("Utc")
            Dim rootNode = Me.document.GetSyntaxRoot(cancellationToken)
            Dim newRootNode = rootNode.ReplaceNode(currentKindNode, utcNode)
            Return New CodeActionEdit(document.UpdateSyntaxRoot(newRootNode))
        End Function
	End Class
End Namespace
