Imports Roslyn.Compilers
Imports Roslyn.Compilers.Common
Imports Roslyn.Compilers.VisualBasic
Imports Roslyn.Services
Imports System.Text
Imports System.Threading
Imports System.Threading.Tasks

Namespace FindingDateTimeNow
	Public NotInheritable Class ChangeNowToUtcNowCodeAction
		Implements ICodeAction

		Private document As IDocument
		Private nowNode As MemberAccessExpressionSyntax

		Public Sub New(ByVal document As IDocument, ByVal nowNode As MemberAccessExpressionSyntax)
			Me.document = document
			Me.nowNode = nowNode
		End Sub

		Public ReadOnly Property Description As String Implements ICodeAction.Description
			Get
				Return "Change Now to UtcNow."
			End Get
		End Property

        Public Function GetEdit(Optional ByVal cancellationToken As CancellationToken = Nothing) As CodeActionEdit Implements ICodeAction.GetEdit
            Dim nameNode = Me.nowNode.Name
            Dim utcNowNode = Syntax.IdentifierName("UtcNow")
            Dim rootNode = Me.document.GetSyntaxRoot(cancellationToken)
            Dim newRootNode = rootNode.ReplaceNode(nameNode, utcNowNode)
            Return New CodeActionEdit(document.UpdateSyntaxRoot(newRootNode))
        End Function
	End Class
End Namespace
